var l_defBookmarkGuid="";
var CLSID_CExtractLinkTool="{68D93D97-31CA-4220-A7E5-4B549455B3E7}";
function invalidateBookmark(){
	if(g_initBookmark){
		refreshBookmark();
	}
	if(g_initToolbar){
		refreshToolbar();
	}
}
function bookmarkOption(guid){
	try{
		if(g_ext.bookmarkOption(guid)){
			g_bookmarkChanged=true;
			invalidateBookmark();
		}
	}catch(e){
		errDlg(ERRCODE_BOOKMARK_SETTING);
	}
}
function bookmarkToolbarOption(idToolbar){
	try{
		guid=g_ext.bandIdToGuid(idToolbar);
		if(g_ext.bookmarkOption(guid,'toolbar')){
			g_toolbarChanged=true;
			g_bookmarkChanged=true;
			invalidateBookmark();
		}
	}catch(e){
		errDlg(ERRCODE_BOOKMARK_SETTING);
	}
}
function addBookmark(clsid){
	try{
		if(g_ext.addBookmark(clsid)){
			invalidateBookmark();
			g_bookmarkChanged=true;
		}
	}catch(e){
		errDlg(ERRCODE_BOOKMARK_SETTING);
	}
}
function delBookmark(guid,name){
	if(confirm("ブックマーク「"+name+"」を削除しますか？\n削除するとツールバーも削除されます。\n\n注：削除は取り消せません")){
		try{
			if(g_ext.delBookmark(guid)){
				invalidateBookmark();
				g_bookmarkChanged=true;
			}
		}catch(e){
			errDlg(ERRCODE_BOOKMARK_SETTING);
		}
	}
}
function _getBookmarkName(bm){
	return (bm.txt?bm.txt:"&lt;名前がありません&gt;");
}
function _getBookmarkNameFromOptions(guid){
	var	options=document.defaultBookmark.v.options
		,name="";
	for(i=0;i<options.length;++i){
		if(guid===options[i].value){
			name=options[i].text;
			break;
		}
	}
	return name;
}

function changeDefaultBookmark(){
	var	options=document.defaultBookmark.v.options
		,selGuid=getSelectedValue(options)
		,change=confirm("ブックマーク「"+_getBookmarkNameFromOptions(selGuid)+"」を規定に設定しますか？");
	if(change){
		g_bookmarkChanged=true;
		try{
			if(g_ext.setDefaultBookmark(selGuid)){
				// update bookmark content
				for(i=0;i<options.length;++i){
					var	guid=options[i].value
						,delBtn=$$(guid+"del"),def=(guid===selGuid);
					if(delBtn){
						delBtn.disabled=def;
					}
					var	defTxt=$$(guid+'def');
					if(defTxt){
						defTxt.style.display=(def?"inline":"none");
					}
				}
				l_defBookmarkGuid=selGuid;
			}
		}catch(e){
			errDlg(ERRCODE_BOOKMARK_SETTING);
		}
	}else{
		// prevent change
		selectOption(options,l_defBookmarkGuid);
	}
}
function _buildBookmarkContent(info){
	var	bookmark=info.bookmark
		,html=null;
	if(bookmark&&(bookmark.length>0)){

		// select default bookmark
		html="";
		html+="<form name=defaultBookmark><label style=\"padding-left:2px;\">\
			規定のブックマーク：&nbsp;<select name=v style=\"width:195px;\" onChange=\"changeDefaultBookmark()\">";
		for(i=0;i<bookmark.length;++i){
			var	bm=bookmark[i];

			// tool
			if(bm.clsid===CLSID_CExtractLinkTool){
				continue;
			}
			
			html+="<option ";
			if(bm.isDefault){
				html+="defaultChecked ";
				l_defBookmarkGuid=bm.guid;
			}
			html+="value="+bm.guid+">"+_getBookmarkName(bm);
		}
		html+="</select></label></form>"
		
		// bookmark list
		html+="<table vspace=0px hspace=0px border=0 cellpadding=0 cellspacing=0>";
		for(i=0;i<bookmark.length;++i){
			var	bm=bookmark[i],txt=_getBookmarkName(bm)
				,disabled="",display="none";

			// tool
			if(bm.clsid===CLSID_CExtractLinkTool){
				continue;
			}
			
			if(bm.isDefault){
				disabled="disabled";
				display="inline";
			}
			tmp='<tr><td style="width:195px;"><span class=cBookmark>'+txt+'\
				<span id="'+bm.guid+'def" style=\"display:'+display+';\"><b>&lt;規定&gt;</b></span></span></td>';
			tmp+='<td>';
			tmp+='<button style="width:8em;" onclick=bookmarkOption(\''+bm.guid+'\');><img src=property.png>&nbsp;詳細設定...</button>';
			tmp+='<button id="'+bm.guid+'del" style="width:5em;" '+disabled+' onclick=\"delBookmark(\''+bm.guid+'\',\''+txt+'\');\"><img src=-.png>&nbsp;削除</button>';
			tmp+="</td></tr>";
			html+=tmp;
		}
		html+="</table>";
	}
	return html;
}
function refreshBookmark(){
	var	html=null;
	try{
		var	txt=g_ext.bookmarkInfo;
		html=_buildBookmarkContent(parseJson(txt));
	}catch(e){}
	if(null===html){
		html='何らかのエラーが発生しました';
	}
	//$("#bookmarkView").empty().html(html);
	$$("bookmarkView").innerHTML=html;
	var	frm=document.defaultBookmark;
	if(frm){
		selectOption(frm.v.options,l_defBookmarkGuid);
	}
}
(function(){refreshBookmark();})();